using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using ExtendedMemberShip;

public partial class UpdateUser : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            // Load the DropDownList with the values
            this.ddlUserNames.Items.Add("- Choose a UserName -");
            this.ddlUserNames.AppendDataBoundItems = true;
            this.ddlUserNames.DataSource = Membership.GetAllUsers();
            this.ddlUserNames.DataBind();
            this.ddlUserNames.DataTextField = "UserName";
            this.ddlUserNames.DataValueField = "UserName";
        }
    }
    protected void SelectBtn_Click(object sender, EventArgs e)
    {
        // Get the selected username
        string UserName = this.ddlUserNames.SelectedValue.ToString();

        //Retreive the user from the database
        MemberShipUser _msu = MemberShip.GetUser(UserName);

        // Populate the form to update the user
        if (_msu != null)
        {
            // Instance of MembershipUser
            MembershipUser _mu = new MembershipUser(_msu.ProviderName,null,_msu.ProviderUserKey,_msu.Email,_msu.PasswordQuestion,
                _msu.Comment,_msu.IsApproved,_msu.IsLockedOut,_msu.CreationDate,_msu.LastLoginDate,_msu.LastActivityDate,
                _msu.LastPasswordChangedDate,_msu.LastLockoutDate);

            // Enable the visibility of the panel
            this.Panel2.Visible = true;
            this.DateOfBirth.Text = _msu.DateOfBirth.ToString("MMM/dd/yyyy");
            this.Email.Text = _msu.Email;
            this.Comment.Text = _msu.Comment;
            this.IsApproved.SelectedValue = _msu.IsApproved ? "1" : "0";
        }
    }
    protected void updatebtn_Click(object sender, EventArgs e)
    {
        // Update the user
        string Email = Server.HtmlEncode(this.Email.Text);
        DateTime DateOfBirth = Convert.ToDateTime(Server.HtmlEncode(this.PopCalendar1.SelectedDate));
        string Comments = Server.HtmlEncode(this.Comment.Text);
        bool isApproved = this.IsApproved.SelectedValue.Equals("1") ? true : false;

        // Execute Update
        MembershipUser _mu = Membership.GetUser(this.ddlUserNames.SelectedValue.ToString());
        _mu.Email = Email;
        _mu.Comment = Comments;
        _mu.IsApproved = isApproved;

        try
        {
            MemberShip.Update(new MemberShipUser(_mu, null, null, DateOfBirth));
            this.ErrorMessage.Text = "User record update successfully!";
        }
        catch
        {
            this.ErrorMessage.Text = "User record could not be updated!";
        }
        this.Panel2.Visible = false;
    }
}
